package flink.zanxiangnet.ad.monitoring.config;

import com.zaxxer.hikari.HikariConfig;
import com.zaxxer.hikari.HikariDataSource;
import flink.zanxiangnet.ad.monitoring.pojo.properties.ApplicationProperties;
import lombok.extern.slf4j.Slf4j;
import org.apache.ibatis.datasource.DataSourceFactory;
import ru.yandex.clickhouse.BalancedClickhouseDataSource;
import ru.yandex.clickhouse.settings.ClickHouseProperties;

import javax.sql.DataSource;
import java.util.Properties;

/**
 * Clickhouse连接池
 */
@Slf4j
public class ClickhouseDataSourceFactory implements DataSourceFactory {

    private Properties props;

    @Override
    public void setProperties(Properties props) {
        this.props = props;
    }

    @Override
    public DataSource getDataSource() {
        System.out.println("========== 创建 CK连接 1次");
        ClickHouseProperties ckProps = new ClickHouseProperties();
        ckProps.setUser(props.getProperty(ApplicationProperties.CK_USERNAME));
        ckProps.setPassword(props.getProperty(ApplicationProperties.CK_PASSWORD));
        ckProps.setSocketTimeout(60 * 1000);

        /*HikariConfig config = new HikariConfig();
        // 此处还可以配置连接池大小，连接超时之类的
        config.setDataSource(dataSource);
        return new HikariDataSource(config);*/
        return new BalancedClickhouseDataSource(props.getProperty(ApplicationProperties.CK_URL), ckProps);
    }
}
