package flink.zanxiangnet.ad.monitoring.config;

import com.mysql.cj.jdbc.MysqlDataSource;
import com.zaxxer.hikari.HikariConfig;
import com.zaxxer.hikari.HikariDataSource;
import flink.zanxiangnet.ad.monitoring.pojo.properties.ApplicationProperties;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.apache.ibatis.datasource.DataSourceFactory;
import ru.yandex.clickhouse.BalancedClickhouseDataSource;
import ru.yandex.clickhouse.settings.ClickHouseProperties;

import javax.sql.DataSource;
import java.sql.SQLException;
import java.util.Properties;

/**
 * Clickhouse连接池
 */
@Slf4j
public class MysqlDataSourceFactory implements DataSourceFactory {

    private Properties props;

    @Override
    public void setProperties(Properties props) {
        this.props = props;
    }

    @Override
    public DataSource getDataSource() {
        MysqlDataSource dataSource = new MysqlDataSource();
        dataSource.setUser(props.getProperty(ApplicationProperties.MYSQL_USERNAME));
        dataSource.setPassword(props.getProperty(ApplicationProperties.MYSQL_PASSWORD));
        dataSource.setUrl(props.getProperty(ApplicationProperties.MYSQL_URL));
        try {
            dataSource.setConnectTimeout(30000);
            dataSource.setInitialTimeout(600000);
            dataSource.setSocketTimeout(60 * 1000);
        } catch (SQLException e) {
            log.error(e.getMessage(), e);
        }
        /*HikariConfig config = new HikariConfig();
        config.setDataSource(dataSource);
        return new HikariDataSource(config);*/
        return dataSource;
    }
}
