package flink.zanxiangnet.ad.monitoring.pojo.dto;

import com.tencent.ads.model.DailyReportsGetListStruct;
import flink.zanxiangnet.ad.monitoring.pojo.entity.AdDataOfDayODS;
import flink.zanxiangnet.ad.monitoring.pojo.entity.AdStatOfDayDWD;
import com.zanxiangnet.module.util.JsonUtil;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.beans.BeanUtils;

import java.time.LocalDate;
import java.util.Date;

@Data
@NoArgsConstructor
@AllArgsConstructor
@Builder
public class AdStatOfDayODSDTO {
    private LocalDate startDate;
    private LocalDate endDate;

    private AdDataOfDayODS adDataOfDayODS;

    public static AdStatOfDayODSDTO byJson(String json) {
        AdDataOfDayDTO dto = JsonUtil.toObj(json, AdDataOfDayDTO.class);
        Date createTime = new Date(dto.getCreateTime());
        DailyReportsGetListStruct struct = dto.getDailyReportsGetListStruct();
        AdDataOfDayODS adODS = new AdDataOfDayODS();
        BeanUtils.copyProperties(struct, adODS);
        adODS.setStatDay(struct.getDate());
        adODS.setAccountId(dto.getAccountId());
        adODS.setCampaignId(struct.getCampaignId());
        adODS.setAgencyAccountId(struct.getAccountId());
        adODS.setWechatAccountId(struct.getWechatAccountId());
        adODS.setAdgroupId(struct.getAdgroupId());
        adODS.setAdId(struct.getAdId());
        adODS.setCreateTime(createTime);
        adODS.removeNull();
        return AdStatOfDayODSDTO.builder()
                .startDate(dto.getStartDate())
                .endDate(dto.getEndDate())
                .adDataOfDayODS(adODS)
                .build();
    }
}
