package flink.zanxiangnet.ad.monitoring.util;

import org.apache.flink.api.common.state.StateTtlConfig;
import org.apache.flink.api.common.time.Time;

public class StateTtlUtil {

    /**
     * 为 rocketDB状态存储构建
     *
     * @param ttl                      过期时间
     * @return
     */
    public static StateTtlConfig rocketDBTtl(Time ttl) {
        return rocketDBTtl(ttl, StateTtlConfig.UpdateType.OnCreateAndWrite, 300);
    }

    /**
     * 为 rocketDB状态存储构建
     *
     * @param ttl                      过期时间
     * @return
     */
    public static StateTtlConfig rocketDBTtl(Time ttl, StateTtlConfig.UpdateType updateType) {
        return rocketDBTtl(ttl, updateType, 300);
    }

    /**
     * 为 rocketDB状态存储构建
     *
     * @param ttl                      过期时间
     * @param queryTimeAfterNumEntries 每次处理多少记录后查询过期时间
     * @return
     */
    public static StateTtlConfig rocketDBTtl(Time ttl, StateTtlConfig.UpdateType updateType, long queryTimeAfterNumEntries) {
        return StateTtlConfig.newBuilder(ttl)
                .setUpdateType(updateType)
                .setStateVisibility(StateTtlConfig.StateVisibility.NeverReturnExpired)
                .setTtlTimeCharacteristic(StateTtlConfig.TtlTimeCharacteristic.ProcessingTime)
                .cleanupInRocksdbCompactFilter(queryTimeAfterNumEntries)
                .build();
    }
}
